// Objective-C API for talking to github.com/nknorg/eth-resolver-go Go package.
//   gobind -lang=objc github.com/nknorg/eth-resolver-go
//
// File is generated by gobind. Do not edit.

#ifndef __Ethresolver_H__
#define __Ethresolver_H__

@import Foundation;
#include "ref.h"
#include "Universe.objc.h"


@class EthresolverConfig;
@class EthresolverResolver;

/**
 * Config is the Resolver configuration.
 */
@interface EthresolverConfig : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) NSString* _Nonnull prefix;
@property (nonatomic) NSString* _Nonnull rpcServer;
@property (nonatomic) NSString* _Nonnull contractAddress;
// skipped field Config.CacheTimeout with unsupported type: time.Duration

@property (nonatomic) long dialTimeout;
@end

/**
 * Resolver implement ETH resolver.
 */
@interface EthresolverResolver : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
/**
 * NewResolver creates a Resolver. If config is nil, the default Resolver config will be used.
 */
- (nullable instancetype)init:(EthresolverConfig* _Nullable)config;
/**
 * Resolve resolves the address and returns the mapping address.
 */
- (NSString* _Nonnull)resolve:(NSString* _Nullable)address error:(NSError* _Nullable* _Nullable)error;
@end

/**
 * CONTRACT_ADDRESS Contract address
 */
FOUNDATION_EXPORT NSString* _Nonnull const EthresolverCONTRACT_ADDRESS;
/**
 * PREFIX Protocol prefix
 */
FOUNDATION_EXPORT NSString* _Nonnull const EthresolverPREFIX;
/**
 * RPC_SERVER RPC server url
 */
FOUNDATION_EXPORT NSString* _Nonnull const EthresolverRPC_SERVER;

@interface Ethresolver : NSObject
// skipped variable DefaultConfig with unsupported type: github.com/nknorg/eth-resolver-go.Config

@end

/**
 * GetDefaultConfig returns the default Resolver config with nil pointer
fields set to default.
 */
FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverGetDefaultConfig(void);

/**
 * MergeConfig merges a given Resolver config with the default Resolver config
recursively. Any non zero value fields will override the default config.
 */
FOUNDATION_EXPORT EthresolverConfig* _Nullable EthresolverMergeConfig(EthresolverConfig* _Nullable config, NSError* _Nullable* _Nullable error);

/**
 * NewResolver creates a Resolver. If config is nil, the default Resolver config will be used.
 */
FOUNDATION_EXPORT EthresolverResolver* _Nullable EthresolverNewResolver(EthresolverConfig* _Nullable config, NSError* _Nullable* _Nullable error);

#endif
